ATERM(1)

NAME
aterm (Afterstep XVT) - a VT102 emulator for the X window system

SYNOPSIS

aterm [options] [-e command [ args ]]

DESCRIPTION

aterm, version 1.0.0, is a colour vt102 terminal emulator, based on rxvt 2.4.8 with Alfredo Kojima's additions of fast transparency, intended as an xterm(1) replacement for users who do not require features such as Tektronix 4014 emulation and toolkit-style configurability. As a result, aterm uses much less swap space -- a significant advantage on a machine serving many X sessions.

It was created with AfterStep Window Manger users in mind, but is not tied to any libraries, and can be used anywhere.

OPTIONS

The aterm options (mostly a subset of xterm's) are listed below. In keeping with the smaller-is-better philosophy, options may be eliminated or default values chosen at compile-time, so options and defaults listed may not accurately reflect the version installed on your system.

Note that aterm permits the resource name to be used as a long-option (--/++ option) so the potential command-line options are far greater than those listed. For example: `aterm --loginShell --color1 Orange'.

-help, --help
    Print out a message describing available options.

-version, --version
    Print out a version with/without list of available options.

-display displayname
    Attempt to open a window on the named X display (-d still respected). In the absence of this option, the display specified by the DISPLAY environment variable is used.

-geometry geom
    Window geometry (-g still respected); resource geometry.

-rv|+rv
    Turn on/off simulated reverse video; resource reverseVideo.

-bg colour
    Window background colour; resource background.

-fg colour
    Window foreground colour; resource foreground.

-pixmap: file[;geom]
    Specify image file for the background and also optionally specify geometry of the image to be cut out of original image, to be used as background, with a geometry string. Note you may need to add quotes to avoid special shell interpretation of the `;' in the command-line; resource backgroundPixmap.

-mst: name
    Specify the name of the Afterstep MyStyle to be used as the base of aterm's look. ForeColor, BackColor, Font, BackPixmap (all texture options) will be used from MyStyle definition, unless some other command line option is specifyed for the same setting. For example -fn will override MyStyle Font. This is available only if used with AfterStep 1.9.28 or later and if compiled with AfterStep libraries support ( --enable-afterstep-lib). resource MyStyle.

-tr|+tr
    Turn on/off pseudo transparency mode. In this mode aterm will use part of root background as it's own background, emulating see-through effect; resource transparent.

-trsb|+trsb
    Turn on/off pseudo transparent scrollbar. Works the same as -tr; resource transpscrollbar.

-tint color
    Turn on pseudo transparency background tinting. Tinting can be done fast and slow way. In fast way it will be done by combining of background color with tinting color using logical function. This function defaults to AND, and it can be changed using -tinttype option - see below. In general solid colors like Blue, Red, Green, Cyan, Magenta, Yellow are good, but you should experiment with it for each background you have. True tinting is more memory and CPU hungry - tinted copy of background image will be created every time you move/resize window. It alows for more smooth tinting thou. You need to build it with --enable-transparency=yes or --enable-background-imageyes option, to be able to use this feature. resource tinting.

-sh amount
    This option allows for darkening/lightening of the background image amount is the %value of the desired brightness, where 100 is the original. if amount is less then 100 - image will be darkened. if amount is less then 0 or more then 100 - image will be lightened. Lightening can cause some strange looking effects if applied on bright image. This option causes aterm to create shaded/lightened copy of the background - it's more memory cosuming as the result. It does not make much difference, though, if applied on non transparent background image. resource shading.

-fade amount
    This option allows for darkening/lightening of colors when aterm is loosing focus. amount is the %value of the desired brightness, where 100 is the original. if amount is less then 100 - colors will be darkened. if amount is less then 0 or more then 100 - colors will be lightened. Lightening can cause some strange looking effects if applied on bright colors. This option causes aterm to use more colors, as the result it is disabled by default. Use --enable-fading ./configure option to enable it. resource fading.

-bgtype type
    Specify type of the transformation to be performed on background image. Possible types are : tile - plain vanilla tiling of the image. scale - original image will be scaled to the aterm's size, every time you resize window. scalev - original image will be scaled to the aterm's height only, every time you resize window. scaleh - original image will be scaled to the aterm's width only, every time you resize window. center - original image will be centered in aterm's window. notile - background color will be padded to image's right/bottom to make it the same size as window is. notileh - background color will be padded to image's right to make it the same width as window is. notilev - background color will be padded to image's bottom to make it the same height as window is. cut - aterm background will be cut out of the source image, as if this source image was tiled across the root window. The portion of the image that lies underneath of window will be used. If AfterStep Pager, asetroot or Esetroot where used to set the root image, then this option can be used in conjunction with -tr option. In this case it will do mentioned transformations to the root pixmap. and use it as aterm's background. resource backgroundType.

-txttype type
    Allows you to specify logical function to be used when displaying text. That will cause aterm to logically combine text with background pixels. That only works with transparent background and background image. Possible values are : and, andReverse, andInverted, xor, or, nor, invert, equiv, invert, orReverse, orInverted, nand; resource textType.

-tinttype type
    Allows you to specify logical function to be used when tinting transparent background. That will cause aterm to logically combine text with background pixels. NOTE: If shading option is used, or background image is specifyed - true type will always be used. That works with bpth transparent background and background image. Possible values are :

    Fast tinting options : and, andReverse, andInverted, xor, or, nor, invert, equiv, invert, orReverse, orInverted, nand,

    Slow tinting: true - will do "true" tinting - that means that background pixel's RGB components will be decreased proportionaly to the RGB components of specified tinting color; resource tintingType.

-cr colour
    The cursor colour; resource cursorColor.

-pr colour
    The mouse pointer colour; resource pointerColor.

-bd colour
    The colour of the border between the xterm scrollbar and the text; resource borderColor.

-bl number
    This option specifies that aterm should askwindow manager to not have a border around term's window; resource borderLess.

-bw number
    This option specifies the width in pixels of the border surrounding the window; resource borderWidth.

-fn fontname
    Main normal text font; resource font.

-fb fontname
    Main bold text font; resource boldFont.

-fm fontname
    Main multicharacter font; resource mfont.

-ib width
    Width of the internal border in pixels; resource internalBorder.

-km mode
    Multiple-character font-set encoding mode; eucj: EUC Japanese encoding. sjis: Shift JIS encoding; resource multichar_encoding.

-grk mode
    Greek keyboard translation; iso: ISO-8859 mapping. ibm: IBM-437 mapping; resource greek_keyboard.

-name name
    Specify the application name under which resources are to be obtained, rather than the default executable file name. Name should not contain `.' or `*' characters. Also sets the icon and title name.

-ls|+ls
    Start as a login-shell/sub-shell; resource loginShell.

-ut|+ut
    Inhibit/enable writing a utmp entry; resource utmpInhibit.

-vb|+vb
    Turn on/off visual bell on receipt of a bell character; resource visualBell.

-sb|+sb
    Turn on/off scrollbar; resource scrollBar.

-si|+si
    Turn on/off scroll-to-bottom on TTY output inhibit; resource scrollTtyOutput has opposite effect.

-sk|+sk
    Turn on/off scroll-to-bottom on keypress; resource scrollKey.

-sr|+sr
    Put scrollbar on right/left; resource scrollBar_right.

-st|+st
    Display scrollbar without/with a trough; resource scrollBar_floating.

-iconic
    Start iconified, if the window manager supports that option.

-sl number
    Save number lines in the scrollback buffer; resource saveLines.

-tn termname
    This option specifies the name of the terminal type to be set in the TERM environment variable. This terminal type must exist in the termcap(5) database and should have li# and co# entries; resource termName.

-e command [arguments]
    Run the command with its command-line arguments in the aterm window; also sets the window title and icon name to be the basename of the program being executed if neither -title (-T) nor -n are given on the command line. If this option is used, it must be the last on the command-line. If there is no -e option then the default is to run the program specified by the SHELL environment variable or, failing that, sh(1).

-title text
    Window title -T still respected); the default title is the basename of the program specified after the \f3\-e\fP option, if any, otherwise the application name; resource title.

-n text
    Icon name; the default name is the basename of the program specified after the \f3\-e\fP option, if any, otherwise the application name; resource iconName.

-C  Capture system console messages.

RESOURCES (available also as long-options)

aterm accepts application defaults set in XAPPLOADDIR/aterm (compile-time defined: usually /etc/X11/Xresources/aterm) and resources set in ~/.Xdefaults or ~/.Xresources. Note that when reading X resources, aterm recognizes two class names: XTerm and Aterm. The class name XTerm allows resources common to both aterm and xterm to be easily configured, while the class name Aterm allows resources unique to aterm, notably colours and key-handling, to be shared between different aterm configurations. If no resources are specified, suitable defaults will be used. Command-line arguments can be used to override resource settings. The following resources are allowed:

geometry: geom
    Create the window with the specified X window geometry [default 80x24]; option -geometry.

background: colour
    Use the specified colour as the window's background colour [default White]; option -bg.

foreground: colour
    Use the specified colour as the window's foreground colour [default Black]; option -fg.

colorn: colour
    Use the specified colour for the colour value n, where 0-7 corresponds to low-intensity (normal) colours and 8-15 corresponds to high-intensity (bold = bright foreground, blink = bright background) colours. The canonical names are as follows: 0=black, 1=red, 2=green, 3=yellow, 4=blue, 5=magenta, 6=cyan, 7=white, but the actual colour names used are listed in the COLORS AND GRAPHICS section.

colorBD: colour
    Use the specified colour to display bold characters when the foreground colour is the default.

colorUL: colour
    Use the specified colour to display underlined characters when the foreground colour is the default.

cursorColor: colour
    Use the specified colour for the cursor. The default is to use the foreground colour; option -cr.

cursorColor2: colour
    Use the specified colour for the colour of the cursor text. For this to take effect, cursorColor must also be specified. The default is to use the background colour.

reverseVideo: boolean
    True: simulate reverse video by foreground and background colours; option -rv, False: regular screen colours [default]; option +rv. See note in COLORS AND GRAPHICS section.

scrollColor: colour
    Use the specified colour for the scrollbar [default #B2B2B2].

troughColor: colour
    Use the specified colour for the scrollbar's trough area [default #969696].

backgroundPixmap: file[;geom]
    Use the specified image file, and cut the area defined by geometry string out of it.

MyStyle: name
    Specify the name of the Afterstep MyStyle to be used as the base of aterm's look. ForeColor, BackColor, Font, BackPixmap (all texture options) will be used from MyStyle definition, unless some other command line option is specifyed for the same setting. For example resource font will override MyStyle Font. This is available only if used with AfterStep 1.9.28 or later and if compiled with AfterStep libraries support ( --enable-afterstep-lib).

transparent
    Turn on/off pseudo transparency mode. In this mode aterm will use part of root background as it's own background, emulating see-through effect;

tinting: color
    Turn on pseudo transparency background tinting. Tinting can be done fast and slow way. In fast way it will be done by combining of background color with tinting color using logical function. This function defaults to AND, and it can be changed using -tinttype option - see below. In general solid colors like Blue, Red, Green, Cyan, Magenta, Yellow are good, but you should experiment with it for each background you have. True tinting is more memory and CPU hungry - tinted copy of background image will be created every time you move/resize window. It alows for more smooth tinting thou. You need to build it with --enable-transparency=yes or --enable-background-image=yes option, to be able to use this feature.

-shading: amount
    This option allows for darkening/lightening of the background image amount is the %value of the desired brightness, where 100 is the original. if amount is less then 100 - image will be darkened. if amount is less then 0 or more then 100 - image will be lightened. Lightening can cause some strange looking effects if applied on bright image. This option causes aterm to create shaded/lightened copy of the background - it's more memory cosuming as the result. It does not make much difference, though, if applied on non transparent background image.

backgroundType: type
    Specify type of the transformation to be performed on background image. Possible types are : tile - plain vanilla tiling of the image. scale - original image will be scaled to the aterm's size, every time you resize window. scalev - original image will be scaled to the aterm's height only, every time you resize window. scaleh - original image will be scaled to the aterm's width only, every time you resize window. center - original image will be centered in aterm's window. notile - background color will be padded to image's right/bottom to make it the same size as window is. notileh - background color will be padded to image's right to make it the same width as window is. notilev - background color will be padded to image's bottom to make it the same height as window is. cut - aterm background will be cut out of the source image, as if this source image was tiled across the root window. The portion of the image that lies underneath of window will be used. If AfterStep Pager, asetroot or Esetroot where used to set the root image, then this option can be used in conjunction with -tr option. In this case it will do mentioned transformations to the root pixmap. and use it as aterm's background.

textType: type
    Allows you to specify logical function to be used when displaying text. That will cause aterm to logically combine text with background pixels. That only works with transparent background and background image. Possible values are : and, andReverse, andInverted, xor, or, nor, invert, equiv, invert, orReverse, orInverted, nand.

tintingType type
    Allows you to specify logical function to be used when tinting transparent background. That will cause aterm to logically combine text with background pixels. NOTE: If shading option is used, or background image is specifyed - true type will always be used. That works with bpth transparent background and background image. Possible values are :

    Fast tinting options : and, andReverse, andInverted, xor, or, nor, invert, equiv, invert, orReverse, orInverted, nand,

    Slow tinting: true - will do "true" tinting - that means that background pixel's RGB components will be decreased proportionaly to the RGB components of specified tinting color.

menu: file[;tag]
    Read in the specified menu file (note the `.menu' extension is optional) and also optionally specify a starting tag to find. See the reference documentation for details on the syntax for the menuBar.

path: path
    Specify the colon-delimited search path for finding files (XPM and menus), in addition to the paths specified by the RXVTPATH and PATH environment variables.

font: fontname
    Select the main text font used [default 7x14]; option -fn.

fontn: fontname
    Specify the alternative font n. The default font values:

        font: | 7x14
        font1: | 6x10
        font2: | 6x13
        font3: | 8x13
        font4: | 9x15

boldFont: fontname
    Specify the name of the bold font to use if colorBD has not been specified and it is not possible to map the default foreground colour to colour 8-15 [default NONE]. This font must be the same height and width as the normal font; option -fb.

mfont: fontname
    Select the main multiple-character text font used [default k14]; option -fk.

mfontn: fontname
    Specify the alternative multiple-character font n. If compiled for multiple-character fonts, the Roman and multiple-character font sizes should match.

multichar_encoding: mode
    Set the encoding mode to be used when multicharacter encoding is received; eucj: EUC Japanese encoding [default for Kanji]. sjis: Shift JIS encoding. big5: BIG5 encoding; option -km.

greek_keyboard: mode
    Set the Greek keyboard translation mode to be used; iso: ISO-8859 mapping (elot-928) [default]. ibm: IBM-437 mapping (DOS codepage 737); option -grk. Use Mode_switch to toggle keyboard input. For more details, see the distributed file README.greek.

title: text
    Set window title string, the default title is the command-line specified after the -e option, if any, otherwise the application name; option -title.

iconName: text
    Set the name used to label the window's icon or displayed in an icon manager window, it also sets the window's title unless it is explicitly set; option -n.

mapAlert: boolean
    True: de-iconify (map) on receipt of a bell character. False: no de-iconify (map) on receipt of a bell character [default].

visualBell: boolean
    True: use visual bell on receipt of a bell character; option -vb. False: no visual bell [default]; option +vb.

loginShell: boolean
    True: start as a login shell by prepending a `-' to argv[0] of the shell; option -ls. False: start as a normal sub-shell [default]; option +ls.

utmpInhibit: boolean
    True: inhibit writing record into the system log file utmp; option -ut. False: write record into the system log file utmp [default]; option +ut.

print-pipe: string
    Specify a command pipe for vt100 printer [default lpr(1)]. Use Print to initiate a screen dump to the printer and Ctrl-Print or Shift-Print to include the scrollback as well.

scrollBar: boolean
    True: enable the scrollbar [default]; option -sb. False: disable the scrollbar; option +sb. Note that the scrollbar type (with/without arrows) is compile-time selected.

smallfont_key: keysym
    If enabled, use Alt-keysym to toggle to a smaller font [default Alt-<]

bigfont_key: keysym
    If enabled, use Alt-keysym to toggle to a bigger font [default Alt->]

saveLines: number
    Save number lines in the scrollback buffer [default 64]; option -sl.

termName: termname
    Specifies the terminal type name to be set in the TERM environment variable; option -tn.

meta8: boolean
    True: handle Meta (Alt) + keypress to set the 8th bit. False: handle Meta (Alt) + keypress as an escape prefix [default].

modifier: string
    Set the Meta key to be enabled by modifier Mod1, Mod2, Mod3, Mod4 or Mod5.

backspacekey: string
    The string to send when the backspace key is pressed. If set to DEC or unset it will send Delete (code 127) or, if shifted, Backspace (code 8) - which can be reversed with the appropriate DEC private mode escape sequence.

deletekey: string
    The string to send when the delete key (not the keypad delete key) is pressed. If unset it will send the sequence traditionally associated with the Execute key.

cutchars: string
    The characters used as delimiters for double-click word selection. The built-in default:
    BACKSLASH `"'&()*,;<=>?@[]{|}

keysym.sym: string
    Associate string with keysym sym (0xFF00 - 0xFFFF). It may contain escape values (\a: bell, \b: backspace, \e, \E: escape, \n: newline, \r: return, \t: tab, \000: octal number) or control characters (^?: delete, ^@: null, ^A ...) and may enclosed with double quotes so that it can start or end with whitespace. The intervening resource name keysym. cannot be omitted. This resource is only available when compiled with KEYSYM_RESOURCE.

THE SCROLLBAR

Lines of text that scroll off the top of the aterm window (resource: saveLines) and can be scrolled back using the scrollbar or by keystrokes. The normal aterm scrollbar has arrows and its behaviour is fairly intuitive. The xterm-scrollbar is without arrows and its behaviour mimics that of xterm. When build with --enable-next-scroll aterm will have NeXT-ish scrollbars. They look nicer and easier in use, but have slightly larger size. Their look and size can be tweaked at compile time by modifying parameters in rxvt.h.

Scroll down with Button1 (xterm-scrollbar) or Shift-Next. Scroll up with Button3 (xterm-scrollbar) or Shift-Prior. Continuous scroll with Button2.

MOUSE REPORTING

To temporarily override mouse reporting, for either the scrollbar or the normal text selection/insertion, hold either the Shift or the Meta (Alt) key while performing the desired mouse action.

If mouse reporting mode is active, the normal scrollbar actions are disabled -- on the assumption that we are using a fullscreen application. Instead, pressing Button1 and Button3 sends ESC[6~ (Next) and ESC[5~ (Prior), respectively. Similarly, clicking on the up and down arrows sends ESC[A (Up) and ESC[B (Down), respectively.

TEXT SELECTION AND INSERTION

The behaviour of text selection and insertion mechanism is similar to xterm(1).

Selection:
    Left click at the beginning of the region, drag to the end of the region and release; Right click to extend the marked region; Left double-click to select a word; Left triple-click to select the entire line.

Insertion:
    Pressing and releasing the Middle mouse button (or Shift-Insert) in an aterm window causes the current text selection to be inserted as if it had been typed on the keyboard.

CHANGING FONTS

You can change fonts on-the-fly, which is to say cycle through the default font and others of various sizes, by using Shift-KP_Add and Shift-KP_Subtract. Or, alternatively (if enabled) with Alt-> and Alt-<, where the actual key can be selected using resources smallfont_key/bigfont_key.

LOGIN STAMP

aterm tries to write an entry into the utmp(5) file so that it can be seen via the who(1) command, and can accept messages. To allow this feature, aterm must be installed setuid root on some systems.

COLORS AND GRAPHICS

If graphics support was enabled at compile-time, aterm can be queried with ANSI escape sequences and can address individual pixels instead of text characters. Note the graphics support is still considered beta code.

In addition to the default foreground and background colours, aterm can display up to 16 colours (8 ANSI colours plus high-intensity bold/blink versions of the same). Here is a list of the colours with their rgb.txt names.

color0 | (black) | = Black
color1 | (red) | = Red3
color2 | (green) | = Green3
color3 | (yellow) | = Yellow3
color4 | (blue) | = Blue3
color5 | (magenta) | = Magenta3
color6 | (cyan) | = Cyan3
color7 | (white) | = AntiqueWhite
color8 | (bright black) | = Grey25
color9 | (bright red) | = Red
color10 | (bright green) | = Green
color11 | (bright yellow) | = Yellow
color12 | (bright blue) | = Blue
color13 | (bright magenta) | = Magenta
color14 | (bright cyan) | = Cyan
color15 | (bright white) | = White
foreground |  | = Black
background |  | = White

It is also possible to specify the colour values of foreground, background, cursorColor, cursorColor2, colorBD, colorUL as a number 0-15, as a convenient shorthand to reference the colour name of color0-color15.

Note that -rv ("reverseVideo: True") simulates reverse video by always swapping the foreground/background colours. This is in contrast to xterm(1) where the colours are only swapped if they have not otherwise been specified. For example,

aterm -fg Black -bg White -rv
    would yield White on Black, while on xterm(1) it would yield Black on White.

ENVIRONMENT

aterm sets the environment variables TERM, COLORTERM and COLORFGBG. The environment variable WINDOWID is set to the X window id number of the aterm window and it also uses and sets the environment variable DISPLAY to specify which display terminal to use. aterm uses the environment variables ATERMPATH, then RXVTPATH and finally PATH to find XPM files.

FILES

/etc/utmp
    System file for login records.

/usr/lib/X11/rgb.txt
    Color names.

SEE ALSO

xterm(1), sh(1), resize(1), X(1), pty(4), tty(4), utmp(5)

Cursor change support is not yet implemented.

Click-and-drag doesn't work with X11 mouse report overriding.

Graphics support is fairly crude.

FTP LOCATION

aterm-0.4.2.tar.gz can be found at the following ftp sites ftp://ftp.afterstep.org/apps/aterm

CURRENT PROJECT COORDINATOR

Project Coordinator
    Sasha Vasko <sasha@aftercode.net>

Web page maintainter
    Sasha Vasko <sasha@aftercode.net>
    <http://www.afterstep.org/aterm>

Online support
    You can meet maintainers online, get support, report bugs and make sugestions on AfterStep IRC channel: #afterstep on freenode.net.

Mailing list
    Support for aterm can be obtained from AfterStep mailing list http://mail.afterstep.org/mailman/listinfo/as-users/.

AUTHORS

John Bovey
    University of Kent, 1992, wrote the original Xvt.

Rob Nation <nation@rocket.sanders.lockheed.com>
    very heavily modified Xvt and came up with Rxvt

Angelo Haritsis <ah@doc.ic.ac.uk>
    wrote the Greek Keyboard Input

mj olesen <olesen@me.QueensU.CA>
    Wrote the menu system.
    Project Coordinator (changes.txt 2.11 to 2.21)

Oezguer Kesim <kesim@math.fu-berlin.de>
    Project Coordinator (changes.txt 2.21a to 2.4.5)

Geoff Wing <gcw@pobox.com>
    Rewrote screen display and text selection routines.
    Project Coordinator (changes.txt 2.4.6 - )

Sasha Vasko <sasha@aftercode.net>
    branched rxvt with Alfredo Kojima additions to aterm.